/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/04/30
* Description        : Main program body.
*******************************************************************************/

/*
 *@Note
 CH32F103开发板的VCC、GND引脚与MPU6050模块的VCC、GND引脚连接
 CH32F103开发板的PA1引脚与MPU6050模块的SDA引脚连接
 CH32F103开发板的PA2引脚与MPU6050模块的SCL引脚连接

*/

#include "debug.h"
#include "iic.h"
#include "mpu6050.h"

/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main(void)
{
	short aacx,aacy,aacz;       //加速度传感器原始数据
	short gyrox,gyroy,gyroz;    //陀螺仪原始数据
	short temp;                 //温度

	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	Delay_Init();
	USART_Printf_Init(115200);
	MPU_Init();                //初始化MPU6050

	printf("SystemClk:%d\r\n",SystemCoreClock);
	printf("MPU6050 TEST\r\n");

	while(1)
	{
	    temp=MPU_Get_Temperature(); //得到温度值
			MPU_Get_Accelerometer(&aacx,&aacy,&aacz);   //得到加速度传感器数据
			MPU_Get_Gyroscope(&gyrox,&gyroy,&gyroz);    //得到陀螺仪数据
			printf("Temperature:%d\r\n",temp);
	    Delay_Ms(500);
	}
}

