#include "iic.h"
#include "debug.h"

//ʼIIC
void IIC_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA, ENABLE );

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1|GPIO_Pin_2;//ʹPA1PA2ΪģIICţPA1ӦSDAPA2ӦSCL
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD ;   //©ģʽ
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    IIC_Idle_State();
}

//IIC״̬
//IICߵSDASCLźͬʱڸߵƽʱ涨ΪIICߵĿ״̬
void IIC_Idle_State()
{
    IIC_SDA_H;
    IIC_SCL_H;

    Delay_Us(4);
}

//IICʼź
//IIC SCLߴڸߵƽʱSDAɸߵƽ͵ƽ䣬ΪIICʼźţÿʼźǰ뱣֤IICߴڿ״̬
void IIC_Start()
{
    IIC_SDA_H;
    IIC_SCL_H;

    Delay_Us(4);

    IIC_SDA_L;
    Delay_Us(4);
    IIC_SCL_L;
    Delay_Us(4);
}

//IICֹͣź
//IIC SCLߴڸߵƽʱSDAɵ͵ƽߵƽ䣬ΪIICֹͣź
void IIC_Stop()
{
    IIC_SDA_L;
    IIC_SCL_H;

    Delay_Us(4);

    IIC_SDA_H;
}

//IICһֽݣ8bit
void IIC_SendByte(u8 data)
{
    u8 i;
    //ȷֽڵĸλbit7
    for (i = 0; i < 8; i++)
    {
        if (data & 0x80)  //ж8λÿһλֵ01
        {
            IIC_SDA_H;
        }
        else
        {
            IIC_SDA_L;
        }

        Delay_Us(4);      //SCL߲ߵ͵ƽ䣬ͨѶʱӣͬʱʱSCLΪߵƽڼȡSDAߵƽ߼
        IIC_SCL_H;
        Delay_Us(4);
        IIC_SCL_L;

        if (i == 7)
        {
            IIC_SDA_H;    //SDAߵƽͷߣȴշӦź
        }

        data <<= 1;       //һbit
        Delay_Us(4);
    }
}

//IICȡһֽ
u8 IIC_ReadByte(unsigned char ack)
{
    u8 i;
    u8 value;

    //1bitΪݵbit7
    value = 0;
    for(i = 0; i < 8; i++)
    {
        value <<= 1;
        IIC_SCL_H;
        Delay_Us(4);
        if (I2C_SDA_READ()) //ʱSCLΪߵƽڼȡSDAߵƽ߼
        {
            value++;
        }
        IIC_SCL_L;
        Delay_Us(4);
    }

    if (!ack)
        IIC_NACK();//nACK
    else
        IIC_ACK(); //ACK

    return value;
}


//IICȴӦź
u8 IIC_WaitAck(void)
{
    uint8_t rvalue;

    IIC_SDA_H;     //ͶͷSDAߣɽն˿SDA
    Delay_Us(4);
    IIC_SCL_H;     //SCLΪߵƽڼȴӦSDAΪߵƽʾNACKźţ֮ΪACKź
    Delay_Us(4);
    if(I2C_SDA_READ())  //ȡSDA״̬жӦͣߵƽȥΪNACKźţ֮ΪACKź
    {
        rvalue = 1;
    }
    else
    {
        rvalue = 0;
    }
    IIC_SCL_L;
    Delay_Us(4);
    return rvalue;
}

//ӦźACK
void IIC_ACK(void)
{
    IIC_SDA_L;
    Delay_Us(4);
    IIC_SCL_H;   //SCLΪߵƽڼȡSDAΪ͵ƽΪACKӦ
    Delay_Us(4);
    IIC_SCL_L;
    Delay_Us(4);
    IIC_SDA_H;
}

//ӦźNACK
void IIC_NACK(void)
{
    IIC_SDA_H;
    Delay_Us(4);
    IIC_SCL_H;   //SCLΪߵƽڼȡSDAΪߵƽΪNACKӦ
    Delay_Us(4);
    IIC_SCL_L;
    Delay_Us(4);
}
