#include "mpu6050.h"
#include "debug.h"

//ʼMPU6050
//ֵ:0,ɹ
//    ,
u8 MPU_Init(void)
{
    u8 res;
    GPIO_InitTypeDef  GPIO_InitStructure;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);     //ʹAFIOʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);    //ʹIO PORTAʱ

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15;              // ˿
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;        //
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;       //IOٶΪ50MHz
    GPIO_Init(GPIOA, &GPIO_InitStructure);                  //趨ʼGPIOA

    GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable,ENABLE); //ֹJTAG,ӶPA15ͨIOʹ,PA15ͨIO!!!

    MPU_AD0_L;                              //MPU6050AD0Ϊ͵ƽ,ӻַΪ:0X68

    IIC_Init();                             //ʼIIC
    MPU_Write_Byte(MPU_PWR_MGMT1_REG,0X80); //λMPU6050
    Delay_Ms(100);
    MPU_Write_Byte(MPU_PWR_MGMT1_REG,0X00); //MPU6050
    MPU_Set_Gyro_Fsr(3);                    //Ǵ,2000dps
    MPU_Set_Accel_Fsr(0);                   //ٶȴ,2g
    MPU_Set_Rate(50);                       //ò50Hz
    MPU_Write_Byte(MPU_INT_EN_REG,0X00);    //رж
    MPU_Write_Byte(MPU_USER_CTRL_REG,0X00); //I2Cģʽر
    MPU_Write_Byte(MPU_FIFO_EN_REG,0X00);   //رFIFO
    MPU_Write_Byte(MPU_INTBP_CFG_REG,0X80); //INTŵ͵ƽЧ
    res=MPU_Read_Byte(MPU_DEVICE_ID_REG);
    if(res==MPU_ADDR)//IDȷ
    {
        MPU_Write_Byte(MPU_PWR_MGMT1_REG,0X01); //CLKSEL,PLL XΪο
        MPU_Write_Byte(MPU_PWR_MGMT2_REG,0X00); //ٶǶ
        MPU_Set_Rate(50);                       //òΪ50Hz
    }else return 1;
    return 0;
}

//MPU6050Ǵ̷Χ
//fsr:0,250dps;1,500dps;2,1000dps;3,2000dps
//ֵ:0,óɹ
//    ,ʧ
u8 MPU_Set_Gyro_Fsr(u8 fsr)
{
    return MPU_Write_Byte(MPU_GYRO_CFG_REG,fsr<<3);//̷Χ
}

//MPU6050ٶȴ̷Χ
//fsr:0,2g;1,4g;2,8g;3,16g
//ֵ:0,óɹ
//    ,ʧ
u8 MPU_Set_Accel_Fsr(u8 fsr)
{
    return MPU_Write_Byte(MPU_ACCEL_CFG_REG,fsr<<3);//üٶȴ̷Χ
}

//MPU6050ֵͨ˲
//lpf:ֵͨ˲Ƶ(Hz)
//ֵ:0,óɹ
//    ,ʧ
u8 MPU_Set_LPF(u16 lpf)
{
    u8 data=0;
    if(lpf>=188)data=1;
    else if(lpf>=98)data=2;
    else if(lpf>=42)data=3;
    else if(lpf>=20)data=4;
    else if(lpf>=10)data=5;
    else data=6;
    return MPU_Write_Byte(MPU_CFG_REG,data);//ֵͨ˲
}

//MPU6050Ĳ(ٶFs=1KHz)
//rate:4~1000(Hz)
//ֵ:0,óɹ
//    ,ʧ
u8 MPU_Set_Rate(u16 rate)
{
    u8 data;
    if(rate>1000)rate=1000;
    if(rate<4)rate=4;
    data=1000/rate-1;
    data=MPU_Write_Byte(MPU_SAMPLE_RATE_REG,data);  //ֵͨ˲
    return MPU_Set_LPF(rate/2); //ԶLPFΪʵһ
}

//õ¶ֵ
//ֵ:¶ֵ(100)
short MPU_Get_Temperature(void)
{
    u8 buf[2];
    short raw;
    float temp;
    MPU_Read_Len(MPU_ADDR,MPU_TEMP_OUTH_REG,2,buf);
    raw=((u16)buf[0]<<8)|buf[1];
    temp=36.53+((double)raw)/340;
    return temp*100;;
}

//õֵ(ԭʼֵ)
//gx,gy,gz:x,y,zԭʼ()
//ֵ:0,ɹ
//    ,
u8 MPU_Get_Gyroscope(short *gx,short *gy,short *gz)
{
    u8 buf[6],res;
    res=MPU_Read_Len(MPU_ADDR,MPU_GYRO_XOUTH_REG,6,buf);
    if(res==0)
    {
        *gx=((u16)buf[0]<<8)|buf[1];
        *gy=((u16)buf[2]<<8)|buf[3];
        *gz=((u16)buf[4]<<8)|buf[5];
        printf("GYRO:  X=%d   Y=%d   Z=%d  \n",*gx,*gy,*gz);
    }
    return res;;
}
//õٶֵ(ԭʼֵ)
//gx,gy,gz:x,y,zԭʼ()
//ֵ:0,ɹ
//    ,
u8 MPU_Get_Accelerometer(short *ax,short *ay,short *az)
{
    u8 buf[6],res;
    res=MPU_Read_Len(MPU_ADDR,MPU_ACCEL_XOUTH_REG,6,buf);
    if(res==0)
    {
        *ax=((u16)buf[0]<<8)|buf[1];
        *ay=((u16)buf[2]<<8)|buf[3];
        *az=((u16)buf[4]<<8)|buf[5];
        printf("ACC:  X=%d   Y=%d   Z=%d  \n",*ax,*ay,*az);
    }
    return res;;
}

//IICд
//addr:ַ
//reg:Ĵַ
//len:д볤
//buf:
//ֵ:0,
//    ,
u8 MPU_Write_Len(u8 addr,u8 reg,u8 len,u8 *buf)
{
    u8 i;
    IIC_Start();
    IIC_SendByte((addr<<1)|0);  //ַ+д
    if(IIC_WaitAck())           //ȴӦ
    {
        IIC_Stop();
        return 1;
    }
    IIC_SendByte(reg); //дĴַ
    IIC_WaitAck();     //ȴӦ
    for(i=0;i<len;i++)
    {
        IIC_SendByte(buf[i]);  //
        if(IIC_WaitAck())      //ȴACK
        {
            IIC_Stop();
            return 1;
        }
    }
    IIC_Stop();
    return 0;
}

//IIC
//addr:ַ
//reg:ҪȡļĴַ
//len:Ҫȡĳ
//buf:ȡݴ洢
//ֵ:0,
//    ,
u8 MPU_Read_Len(u8 addr,u8 reg,u8 len,u8 *buf)
{
    IIC_Start();
    IIC_SendByte((addr<<1)|0);//ַ+д
    if(IIC_WaitAck())  //ȴӦ
    {
        IIC_Stop();
        return 1;
    }
    IIC_SendByte(reg); //дĴַ
    IIC_WaitAck();     //ȴӦ
    IIC_Start();
    IIC_SendByte((addr<<1)|1);//ַ+
    IIC_WaitAck();     //ȴӦ
    while(len)
    {
        if(len==1)*buf=IIC_ReadByte(0);//,nACK
        else *buf=IIC_ReadByte(1);     //,ACK
        len--;
        buf++;
    }
    IIC_Stop(); //һֹͣ
    return 0;
}

//IICдһֽ
//reg:Ĵַ
//data:
//ֵ:0,
//    ,
u8 MPU_Write_Byte(u8 reg,u8 data)
{
    IIC_Start();
    IIC_SendByte((MPU_ADDR<<1)|0);//ַ+д
    if(IIC_WaitAck())  //ȴӦ
    {
        IIC_Stop();
        return 1;
    }
    IIC_SendByte(reg); //дĴַ
    IIC_WaitAck();     //ȴӦ
    IIC_SendByte(data);//
    if(IIC_WaitAck())  //ȴACK
    {
        IIC_Stop();
        return 1;
    }
    IIC_Stop();
    return 0;
}

//IICһֽ
//reg:Ĵַ
//ֵ:
u8 MPU_Read_Byte(u8 reg)
{
    u8 res;
    IIC_Start();
    IIC_SendByte((MPU_ADDR<<1)|0);//ַ+д
    IIC_WaitAck();     //ȴӦ
    IIC_SendByte(reg); //дĴַ
    IIC_WaitAck();     //ȴӦ
    IIC_Start();
    IIC_SendByte((MPU_ADDR<<1)|1);//ַ+
    IIC_WaitAck();     //ȴӦ
    res=IIC_ReadByte(0);//ȡ,nACK
    IIC_Stop();         //һֹͣ
    return res;
}


